@echo off

rem Batch-file for installation and uninstallation of the Kinetic
rem Compiler version 1.10, Reduced DOS version
rem and for setting the path when GNU C-compiler (djgpp) is used.
rem CopyWrong 1994-1995 by
rem Keld Nielsen (kn@kin.kiku.dk)
rem and
rem Kenneth Geisshirt (kneth@fatou.ruc.dk)
rem Department of Life Sciences and Chemistry
rem Roskilde University
rem P.O. Box 260
rem 4000 Roskilde
rem Denmark
rem
rem Last updated: 12 March 1997 by KN
rem
rem Please see README for further information, and COPYING for
rem legal matters.

rem Installation:  Set the path of C-compiler (from the package djgpp).
rem                You can do these by change to the directory
rem                \kc.bin\dos and type: kcidos path
rem                Change to the directory \kc.bin\dos,
rem                and type: kcidos install
rem                When the installation has finised, you can run
rem                numerical integrations by using kci.bat, as follows
rem                kci filename
rem                e.g change to directory \kc.bin\test
rem                and type: kci open.des
rem Uninstallation:Two modes:
rem                1) You can remove executable files by the following
rem                   procedure. Change to \kc.bin\dos and type:
rem                   kcidos uninstall
rem                2) You can remove executable files, and other files which
rem                   depend on the plateform by the following procedure.
rem                   Change to \kc.bin\dos and type:
rem                   kcidos uninsfull
rem Setting the path for the C-compiler: You have set the path to the
rem                C-compiler (included in the package djgpp) everytime
rem                you restart the computer. You can do these by the
rem                following procedure. Change to \kc.bin\dos and type:
rem                kcidos path
rem


if "%1"=="install" goto INSTALL
if "%1"=="uninstall" goto UNINSTALL
if "%1"=="uninsfull" goto UNINSFULL
if "%1"=="path" goto SETDJGPPPATH

goto END

:INSTALL
echo "Making the Kinetic Compiler."
cd ..\solvers
copy ..\dos\makesolv.dos makefile
copy *.h ..\num\.
copy kksoldos.c ..\num\.
make
del makefile
cd ..\src
copy ..\dos\makesrc.dos makefile
make
del makefile
copy kc ..\bin\.
del kc
cd ..\dos
copy kci.bat ..\bin\.
goto END

:UNINSTALL

echo "Delete old files."
del ..\bin\kc
del ..\bin\kci.bat
del ..\lib\libkc.a
del ..\num\*.h
del ..\num\*.c
del ..\src\*.o
del ..\src\makefile
del ..\solvers\*.o
del ..\solvers\makefile
goto END

:UNINSFULL

echo "Delete old files."
del ..\bin\kc
del ..\bin\kci.bat
del ..\lib\libkc.a
del ..\num\*.h
del ..\num\*.c
cd ..\src
del *.o
del parser.c
del lex.c
del makefile
cd ..\solvers
del *.o
del makefile
cd ..\dos
goto END

:SETDJGPPPATH
echo on
PATH= C:\DOS;C:\DJGPP\BIN;C:\KC.BIN\BIN
c:\djgpp\bin\setdjgpp c:\djgpp c:/djgpp
set TMPDIR = c:/tmp
set GO32TMP = c:/tmp
goto END

:END
