/*************************************************************************
  CodeGenCall - callee of all code generators.

  CopyWrong 1993-1995 by
  Kenneth Geisshirt (kneth@fatou.ruc.dk)
  Department of Life Sciences and Chemistry
  Roskilde University
  P.O. Box 260
  4000 Roskilde
  Denmark

  See kc.tex for details.

  Last updated: 8 March 1997 by KN
  Reduced DOS version
**************************************************************************/


#include <stdio.h>
#include "config.h"
#include "tableman.h"

/* import all code generators */
#include "kgode.h"

void CodeGenCall(int mode) {

/**************************************************************************
  modes:
  1 - KGode (kci)         (K. Geisshirt and K. Nielsen)
***************************************************************************/

  FILE *code, *code_h, *code_c;

  switch (mode) {
  case 1:
    code_c=fopen("model.c", "w");
    code_h=fopen("model.h", "w");
    KGode(code_c, code_h);
    fclose(code_c);
    fclose(code_h);
    break;
  default:
    fprintf(stderr, "CodeGenCall: mode %d is not supported. Run kc -h for help.\n", mode);
  }; /* switch */
} /* CodeGenCall */
