/*************************************************************************** 
  Main program for kc. It is actually just parsing arguments and then
  gives control to the parser.

  CopyWrong 1992-1995 by 
  Kenneth Geisshirt (kneth@fatou.ruc.dk)
  Department of Life Sciences and Chemistry
  Roskilde University
  P.O. Box 260
  4000 Roskilde
  Denmark
  
  See kc.tex for details.

  Last updated: 4 March 1997 by KN
  Reduced version
***************************************************************************/


#define DefaultMode 1

#include "config.h"
#include <stdio.h>
#include <malloc.h>
#include "codecall.h"
#include "misc.h"

int    mode;

#include "parser.c"

int main(int argc, char *argv[]) {

  int    j, c;
  extern char *optarg;

  mode=DefaultMode;
  printf("kc v%s, CopyWrong by Kenneth Geisshirt, 1992-1995\n", VERSION);
  verbose=1;                                             /* printing  */
  while ((c=getopt(argc, argv, "vhdm:"))!=EOF)
    switch (c) {
    case 'h':
      printf("\nOptions:\n");
      printf("  -h : this text.\n");
      printf("  -v : verbose off\n");
      printf("  -mx: mode\n");
      printf("       1 = kci    (Numerical integrators)\n");
      printf("E-mail: kneth@fatou.ruc.dk\n\n");
      printf("This program comes with absolutely no warranty!\n");
      exit(0);
      break;
    case 'm':
      j=0;
      mode=0;
      while ((optarg[j]!=' ') && (optarg[j]!='\0')) {
	mode=mode*10+(int)(optarg[j]-'0');
	j++;
      };
      break;
    case 'v':
      verbose=0;
      break;
    default:
      fprintf(stderr, "Warning: Option %1s ignored.\n", argv[i][1]);
      break;
    } /* switch */
  (void) yyparse();
  CodeGenCall(mode);
}
