/* File used in the Dos installation of KCI-program             */
/* Create the following files: kinrc.bat, kciinst.bat, kci.bat  */
/* 14/3 1997, KN                                                */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
/* #include <math.h>*/

#define llgh 256

char    drvname[llgh];
char	errmes[llgh];
FILE	*fdata;

void Error_Message(int level, char message[llgh]) {
/* Error_Message: level=0, program is aborted; level=1, a warning */
  switch (level) {
  case 0: printf("Program is aborted:\n %s\n",message); exit(1); break;
  case 1: printf("Warning: %s.\n",message); break;
  } /* switch */
} /* Error_Message */

void main(int argc,char *argv[]) {

  switch (argc) {
    case 1: strcpy(drvname,"C"); break;
    case 2: strcpy(drvname,argv[1]); break;
  }

  /* KINRC.BAT */
  if ((fdata  = fopen("kinrc.bat","wt")) == NULL)
    Error_Message(0,strcpy(errmes,"Not able to make the file KINRC.BAT\n"));
  fprintf(fdata,"PATH=.;C:\\DOS;%s:\\DJGPP\\BIN;%s:\\KC.BIN\\bin\n",drvname,drvname);
  fprintf(fdata,"%s:\\djgpp\\bin\\setdjgpp %s:\\djgpp %s:/djgpp\n",drvname,drvname,drvname);
  fprintf(fdata,"set TMPDIR = %s:/tmp\n",drvname);
  fprintf(fdata,"set GO32TMP = %s:/tmp\n",drvname);
  fclose(fdata);

  /* KCIINST.BAT */
  if ((fdata  = fopen("kciinst.bat","wt")) == NULL)
    Error_Message(0,strcpy(errmes,"Not able to make the file KCIINST.BAT\n"));
  fprintf(fdata,"echo \"Making the Kinetic Compiler.\"\n");
  fprintf(fdata,"cd %s:\\kc.bin\\solvers\n",drvname);
  fprintf(fdata,"copy %s:\\kc.bin\\dos\\makesolv.dos makefile\n",drvname);
  fprintf(fdata,"copy *.h %s:\\kc.bin\\num\\.\n",drvname);
  fprintf(fdata,"copy kksoldos.c %s:\\kc.bin\\num\\.\n",drvname);
  fprintf(fdata,"make\n");
  fprintf(fdata,"del makefile\n");
  fprintf(fdata,"cd %s:\\kc.bin\\src\n",drvname);
  fprintf(fdata,"copy %s:\\kc.bin\\dos\\makesrc.dos makefile\n",drvname);
  fprintf(fdata,"make\n");
  fprintf(fdata,"del makefile\n");
  fprintf(fdata,"copy kc %s:\\kc.bin\\bin\\.\n",drvname);
  fprintf(fdata,"del kc\n");
  fclose(fdata);

  /* KCI.BAT */
  if ((fdata  = fopen("kci.bat","wt")) == NULL)
    Error_Message(0,strcpy(errmes,"Not able to make the file KCI.BAT\n"));
  fprintf(fdata,"@echo off\n");
  fprintf(fdata,"go32 %s:\\kc.bin\\bin\\kc -m1 -v < \%1\n",drvname);
  fprintf(fdata,"copy %s:\\kc.bin\\num\\kksoldos.c > kci.log\n",drvname);
  fprintf(fdata,"copy %s:\\kc.bin\\num\\matrix.h  >> kci.log\n",drvname);
  fprintf(fdata,"copy %s:\\kc.bin\\num\\complex.h >> kci.log\n",drvname);
  fprintf(fdata,"copy %s:\\kc.bin\\num\\odeserv.h >> kci.log\n",drvname);
  fprintf(fdata,"copy %s:\\kc.bin\\num\\odesolv.h >> kci.log\n",drvname);
  fprintf(fdata,"copy %s:\\kc.bin\\lib\\libkc.a   >> kci.log\n",drvname);
  fprintf(fdata,"gcc kksoldos.c -c\n");
  fprintf(fdata,"gcc kksoldos.o libkc.a -lm -lpc -O2 -o _simul\n");
  fprintf(fdata,"del model.c\n");
  fprintf(fdata,"del model.h\n");
  fprintf(fdata,"del kksoldos.c\n");
  fprintf(fdata,"del matrix.h\n");
  fprintf(fdata,"del complex.h\n");
  fprintf(fdata,"del odeserv.h\n");
  fprintf(fdata,"del odesolv.h\n");
  fprintf(fdata,"del kksoldos.o\n");
  fprintf(fdata,"del libkc.a\n");
  fprintf(fdata,"go32 _simul\n");
  fprintf(fdata,"del _simul\n");
  fprintf(fdata,"del kci.log\n");
  fclose(fdata);

} /* main */
